diff -r ee55d0546576 src/npf.cpp
--- a/src/npf.cpp	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/npf.cpp	Sat Apr 25 19:58:24 2009 +0200
@@ -16,6 +16,7 @@
 #include "pbs.h"
 #include "settings_type.h"
 #include "pathfind.h"
+#include "infrastructure_func.h"
 
 static AyStar _npf_aystar;
 
@@ -548,25 +549,35 @@
  */
 static bool CanEnterTileOwnerCheck(Owner owner, TileIndex tile, DiagDirection enterdir)
 {
-	if (IsTileType(tile, MP_RAILWAY) || // Rail tile (also rail depot)
-			IsRailwayStationTile(tile) ||   // Rail station tile
-			IsRoadDepotTile(tile) ||        // Road depot tile
-			IsStandardRoadStopTile(tile)) { // Road station tile (but not drive-through stops)
-		return IsTileOwner(tile, owner);  // You need to own these tiles entirely to use them
-	}
+	switch (GetTileType(tile)) {
+		case MP_RAILWAY:
+			/* rail depot */
+			if (IsRailDepot(tile)) return IsDepotUsageAllowed(tile, owner, VEH_TRAIN);
+			/* waypoint */
+			if (IsRailWaypoint(tile)) return IsWaypointUsageAllowed(GetWaypointByTile(tile), owner);
+			/* other rail tile */
+			return IsRailUsageAllowed(tile, owner);
 
-	switch (GetTileType(tile)) {
 		case MP_ROAD:
+			/* road depot */
+			if (IsRoadDepot(tile)) return IsDepotUsageAllowed(tile, owner, VEH_ROAD);
 			/* rail-road crossing : are we looking at the railway part? */
 			if (IsLevelCrossing(tile) &&
 					DiagDirToAxis(enterdir) != GetCrossingRoadAxis(tile)) {
-				return IsTileOwner(tile, owner); // Railway needs owner check, while the street is public
+				return IsRailUsageAllowed(tile, owner); // Railway needs owner check, while the street is public
 			}
+			break;
+
+		case MP_STATION:
+			/* rail station */
+			if (IsRailwayStation(tile)) return IsStationUsageAllowed(tile, owner, VEH_TRAIN);
+			/* standard road stop */
+			if (IsStandardRoadStopTile(tile)) return IsStationUsageAllowed(tile, owner, VEH_ROAD);
 			break;
 
 		case MP_TUNNELBRIDGE:
 			if (GetTunnelBridgeTransportType(tile) == TRANSPORT_RAIL) {
-				return IsTileOwner(tile, owner);
+				return IsRailUsageAllowed(tile, owner);
 			}
 			break;
 
@@ -977,7 +988,7 @@
 	FOR_ALL_DEPOTS(depot) {
 		/* Check if this is really a valid depot, it is of the needed type and
 		 * owner */
-		if (IsDepotTypeTile(depot->xy, type) && IsTileOwner(depot->xy, owner))
+		if (IsDepotTypeTile(depot->xy, type) && IsDepotUsageAllowed(depot->xy, owner, (VehicleType)type))
 			/* If so, let's add it to the queue, sorted by distance */
 			depots.push(&depots, depot, DistanceManhattan(tile, depot->xy));
 	}
diff -r ee55d0546576 src/order_cmd.cpp
--- a/src/order_cmd.cpp	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/order_cmd.cpp	Sat Apr 25 19:58:24 2009 +0200
@@ -20,6 +20,7 @@
 #include "oldpool_func.h"
 #include "depot_base.h"
 #include "settings_type.h"
+#include "infrastructure_func.h"
 
 #include "table/strings.h"
 
@@ -432,7 +433,7 @@
 
 			const Station *st = GetStation(new_order.GetDestination());
 
-			if (st->owner != OWNER_NONE && !CheckOwnership(st->owner)) return CMD_ERROR;
+			if (!IsStationUsageAllowed(st, v)) return CMD_ERROR;
 
 			if (!CanVehicleUseStation(v, st)) return_cmd_error(STR_ERROR_CAN_T_ADD_ORDER);
 			for (Vehicle *u = v->FirstShared(); u != NULL; u = u->NextShared()) {
@@ -478,7 +479,7 @@
 
 					const Station *st = GetStation(new_order.GetDestination());
 
-					if (!CheckOwnership(st->owner) ||
+					if (!IsStationUsageAllowed(st, v) ||
 							!CanVehicleUseStation(v, st) ||
 							st->Airport()->nof_depots == 0) {
 						return CMD_ERROR;
@@ -488,7 +489,7 @@
 
 					const Depot *dp = GetDepot(new_order.GetDestination());
 
-					if (!CheckOwnership(GetTileOwner(dp->xy))) return CMD_ERROR;
+					if (!IsDepotUsageAllowed(dp->xy, v)) return CMD_ERROR;
 
 					switch (v->type) {
 						case VEH_TRAIN:
@@ -523,7 +524,7 @@
 			if (!IsValidWaypointID(new_order.GetDestination())) return CMD_ERROR;
 			const Waypoint *wp = GetWaypoint(new_order.GetDestination());
 
-			if (!CheckOwnership(wp->owner)) return CMD_ERROR;
+			if (!IsWaypointUsageAllowed(wp, v->owner)) return CMD_ERROR;
 
 			/* Order flags can be any of the following for waypoints:
 			 * [non-stop]
diff -r ee55d0546576 src/order_gui.cpp
--- a/src/order_gui.cpp	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/order_gui.cpp	Sat Apr 25 19:58:24 2009 +0200
@@ -24,6 +24,7 @@
 #include "tilehighlight_func.h"
 #include "network/network.h"
 #include "settings_type.h"
+#include "infrastructure_func.h"
 
 #include "table/sprites.h"
 #include "table/strings.h"
@@ -297,18 +298,16 @@
 	if (_settings_game.order.gotodepot) {
 		switch (GetTileType(tile)) {
 			case MP_RAILWAY:
-				if (v->type == VEH_TRAIN && IsTileOwner(tile, _local_company)) {
-					if (IsRailDepot(tile)) {
-						order.MakeGoToDepot(GetDepotByTile(tile)->index, ODTFB_PART_OF_ORDERS);
-						if (_ctrl_pressed) order.SetDepotOrderType((OrderDepotTypeFlags)(order.GetDepotOrderType() ^ ODTFB_SERVICE));
-						if (_settings_client.gui.new_nonstop) order.SetNonStopType(ONSF_NO_STOP_AT_INTERMEDIATE_STATIONS);
-						return order;
-					}
+				if (IsRailDepot(tile) && v->type == VEH_TRAIN && IsDepotUsageAllowed(tile, v)) {
+					order.MakeGoToDepot(GetDepotByTile(tile)->index, ODTFB_PART_OF_ORDERS);
+					if (_ctrl_pressed) order.SetDepotOrderType((OrderDepotTypeFlags)(order.GetDepotOrderType() ^ ODTFB_SERVICE));
+					if (_settings_client.gui.new_nonstop) order.SetNonStopType(ONSF_NO_STOP_AT_INTERMEDIATE_STATIONS);
+					return order;
 				}
 				break;
 
 			case MP_ROAD:
-				if (IsRoadDepot(tile) && v->type == VEH_ROAD && IsTileOwner(tile, _local_company)) {
+				if (IsRoadDepot(tile) && v->type == VEH_ROAD && IsDepotUsageAllowed(tile, v)) {
 					order.MakeGoToDepot(GetDepotByTile(tile)->index, ODTFB_PART_OF_ORDERS);
 					if (_ctrl_pressed) order.SetDepotOrderType((OrderDepotTypeFlags)(order.GetDepotOrderType() ^ ODTFB_SERVICE));
 					if (_settings_client.gui.new_nonstop) order.SetNonStopType(ONSF_NO_STOP_AT_INTERMEDIATE_STATIONS);
@@ -318,7 +317,7 @@
 
 			case MP_STATION:
 				if (v->type != VEH_AIRCRAFT) break;
-				if (IsHangar(tile) && IsTileOwner(tile, _local_company)) {
+				if (IsHangar(tile) && IsStationUsageAllowed(tile, v)) {
 					order.MakeGoToDepot(GetStationIndex(tile), ODTFB_PART_OF_ORDERS);
 					if (_ctrl_pressed) order.SetDepotOrderType((OrderDepotTypeFlags)(order.GetDepotOrderType() ^ ODTFB_SERVICE));
 					return order;
@@ -327,7 +326,7 @@
 
 			case MP_WATER:
 				if (v->type != VEH_SHIP) break;
-				if (IsShipDepot(tile) && IsTileOwner(tile, _local_company)) {
+				if (IsShipDepot(tile) && IsDepotUsageAllowed(tile, v)) {
 					TileIndex tile2 = GetOtherShipDepotTile(tile);
 
 					order.MakeGoToDepot(GetDepotByTile(tile < tile2 ? tile : tile2)->index, ODTFB_PART_OF_ORDERS);
@@ -343,7 +342,7 @@
 	/* check waypoint */
 	if (IsRailWaypointTile(tile) &&
 			v->type == VEH_TRAIN &&
-			IsTileOwner(tile, _local_company)) {
+			IsWaypointUsageAllowed(GetWaypointByTile(tile), v->owner)) {
 		order.MakeGoToWaypoint(GetWaypointByTile(tile)->index);
 		if (_settings_client.gui.new_nonstop != _ctrl_pressed) order.SetNonStopType(ONSF_NO_STOP_AT_ANY_STATION);
 		return order;
@@ -353,7 +352,7 @@
 		StationID st_index = GetStationIndex(tile);
 		const Station *st = GetStation(st_index);
 
-		if (st->owner == _local_company || st->owner == OWNER_NONE) {
+		if (IsStationUsageAllowed(tile, v)) {
 			byte facil;
 			(facil = FACIL_DOCK, v->type == VEH_SHIP) ||
 			(facil = FACIL_TRAIN, v->type == VEH_TRAIN) ||
diff -r ee55d0546576 src/ottdres.rc.in
--- a/src/ottdres.rc.in	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/ottdres.rc.in	Sat Apr 25 19:58:24 2009 +0200
@@ -64,8 +64,8 @@
 //
 
 VS_VERSION_INFO VERSIONINFO
- FILEVERSION 0,8,0,@@REVISION@@
- PRODUCTVERSION 0,8,0,@@REVISION@@
+ FILEVERSION 0,8,0,16141
+ PRODUCTVERSION 0,8,0,16141
  FILEFLAGSMASK 0x3fL
 #ifdef _DEBUG
  FILEFLAGS 0x1L
@@ -83,14 +83,14 @@
             VALUE "Comments", "This program is licensed under the GNU General Public License.\0"
             VALUE "CompanyName", "OpenTTD Development Team\0"
             VALUE "FileDescription", "OpenTTD\0"
-            VALUE "FileVersion", "Development @@VERSION@@\0"
+            VALUE "FileVersion", "IS2.0-beta2\0"
             VALUE "InternalName", "openttd\0"
             VALUE "LegalCopyright", "Copyright \xA9 OpenTTD Developers 2002-2009. All Rights Reserved.\0"
             VALUE "LegalTrademarks", "\0"
             VALUE "OriginalFilename", "openttd.exe\0"
             VALUE "PrivateBuild", "\0"
             VALUE "ProductName", "OpenTTD\0"
-            VALUE "ProductVersion", "Development @@VERSION@@\0"
+            VALUE "ProductVersion", "IS2.0-beta2\0"
             VALUE "SpecialBuild", "-\0"
         END
     END
diff -r ee55d0546576 src/pbs.cpp
--- a/src/pbs.cpp	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/pbs.cpp	Sat Apr 25 19:58:24 2009 +0200
@@ -233,7 +233,7 @@
 {
 	FindTrainOnTrackInfo *info = (FindTrainOnTrackInfo *)data;
 
-	if (v->type == VEH_TRAIN && !(v->vehstatus & VS_CRASHED) && HasBit((TrackBits)v->u.rail.track, TrackdirToTrack(info->res.trackdir))) {
+	if (v->type == VEH_TRAIN && !(v->vehstatus & VS_CRASHED) && (v->u.rail.track == TRACK_BIT_WORMHOLE || HasBit((TrackBits)v->u.rail.track, TrackdirToTrack(info->res.trackdir)))) {
 		v = v->First();
 
 		/* ALWAYS return the lowest ID (anti-desync!) */
@@ -268,6 +268,40 @@
 }
 
 /**
+ * Find a train on a reservation in a single direction.
+ * @param tile The reserved tile.
+ * @param trackdir The reserved trackdir to start searching.
+ * @param owner The owner of the vehicle. If no owner is known yet, specify INVALID_OWNER.
+ * @param rts The railtypes the vehicle can use. If not known yet, specify INVALID_RAILTYPES.
+ * @return The vehicle this reservation (possibly) belongs to.
+ */
+static Vehicle *FindTrainForReservationDir(TileIndex tile, Trackdir trackdir, Owner owner, RailTypes rts)
+{
+	FindTrainOnTrackInfo ftoti;
+	/* Ignore one-way signals, as we might be searching the wrong way */
+	ftoti.res = FollowReservation(owner, rts, tile, trackdir, true);
+
+	FindVehicleOnPos(ftoti.res.tile, &ftoti, FindTrainOnTrackEnum);
+	if (ftoti.best != NULL) return ftoti.best;
+
+	/* Special case for stations: check the whole platform for a vehicle. */
+	if (IsRailwayStationTile(ftoti.res.tile)) {
+		TileIndexDiff diff = TileOffsByDiagDir(TrackdirToExitdir(ReverseTrackdir(ftoti.res.trackdir)));
+		for (TileIndex st_tile = ftoti.res.tile + diff; IsCompatibleTrainStationTile(st_tile, ftoti.res.tile); st_tile += diff) {
+			FindVehicleOnPos(st_tile, &ftoti, FindTrainOnTrackEnum);
+			if (ftoti.best != NULL) return ftoti.best;
+		}
+	}
+
+	/* Special case for bridges/tunnels: check the other end as well. */
+	if (IsTileType(ftoti.res.tile, MP_TUNNELBRIDGE)) {
+		FindVehicleOnPos(GetOtherTunnelBridgeEnd(ftoti.res.tile), &ftoti, FindTrainOnTrackEnum);
+		if (ftoti.best != NULL) return ftoti.best;
+	}
+	return NULL;
+}
+
+/**
  * Find the train which has reserved a specific path.
  *
  * @param tile A tile on the path.
@@ -279,31 +313,22 @@
 	assert(HasReservedTracks(tile, TrackToTrackBits(track)));
 	Trackdir  trackdir = TrackToTrackdir(track);
 
-	RailTypes rts = GetRailTypeInfo(GetTileRailType(tile))->compatible_railtypes;
-
 	/* Follow the path from tile to both ends, one of the end tiles should
-	 * have a train on it. We need FollowReservation to ignore one-way signals
-	 * here, as one of the two search directions will be the "wrong" way. */
+	 * have a train on it. Since we don't know the vehicle yet,
+	 * we don't know which tiles it can access with regards to ownership and infrastructure sharing,
+	 * nor do we know which rail types it is compatible with.
+	 * Therefore we first do a test run without ownership or railtype checks.
+	 * If this yields a vehicle, we test again using the now-known owner and railtype info.
+	 * If this still yields a vehicle, we return it as it is the correct one.
+	 */
 	for (int i = 0; i < 2; ++i, trackdir = ReverseTrackdir(trackdir)) {
-		FindTrainOnTrackInfo ftoti;
-		ftoti.res = FollowReservation(GetTileOwner(tile), rts, tile, trackdir, true);
-
-		FindVehicleOnPos(ftoti.res.tile, &ftoti, FindTrainOnTrackEnum);
-		if (ftoti.best != NULL) return ftoti.best;
-
-		/* Special case for stations: check the whole platform for a vehicle. */
-		if (IsRailwayStationTile(ftoti.res.tile)) {
-			TileIndexDiff diff = TileOffsByDiagDir(TrackdirToExitdir(ReverseTrackdir(ftoti.res.trackdir)));
-			for (TileIndex st_tile = ftoti.res.tile + diff; IsCompatibleTrainStationTile(st_tile, ftoti.res.tile); st_tile += diff) {
-				FindVehicleOnPos(st_tile, &ftoti, FindTrainOnTrackEnum);
-				if (ftoti.best != NULL) return ftoti.best;
-			}
-		}
-
-		/* Special case for bridges/tunnels: check the other end as well. */
-		if (IsTileType(ftoti.res.tile, MP_TUNNELBRIDGE)) {
-			FindVehicleOnPos(GetOtherTunnelBridgeEnd(ftoti.res.tile), &ftoti, FindTrainOnTrackEnum);
-			if (ftoti.best != NULL) return ftoti.best;
+		Vehicle *v = FindTrainForReservationDir(tile, trackdir, INVALID_OWNER, INVALID_RAILTYPES);
+		if (v == NULL) continue;
+		RailTypes rts = GetRailTypeInfo(v->u.rail.railtype)->compatible_railtypes;
+		v = FindTrainForReservationDir(tile, trackdir, v->owner, rts);
+		/* Also verify that the train can actally use the start tile */
+		if (v != NULL && IsRailwayTileUsageAllowed(tile, v->owner) && HasBit(rts, GetTileRailType(tile))) {
+			return v;
 		}
 	}
 
diff -r ee55d0546576 src/rev.cpp.in
--- a/src/rev.cpp.in	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/rev.cpp.in	Sat Apr 25 19:58:24 2009 +0200
@@ -20,7 +20,7 @@
  * norev000 is for non-releases that are made on systems without
  * subversion or sources that are not a checkout of subversion.
  */
-const char _openttd_revision[] = "@@VERSION@@";
+const char _openttd_revision[] = "IS2.0-beta2";
 
 /**
  * Let us know if current build was modified. This detection
@@ -45,11 +45,11 @@
  * final release will always have a lower version number than the released
  * version, thus making comparisions on specific revisions easy.
  */
-const uint32 _openttd_newgrf_version = 0 << 28 | 8 << 24 | 0 << 20 | 0 << 19 | (@@REVISION@@ & ((1 << 19) - 1));
+const uint32 _openttd_newgrf_version = 0 << 28 | 8 << 24 | 0 << 20 | 0 << 19 | (16141 & ((1 << 19) - 1));
 
 #ifdef __MORPHOS__
 /**
  * Variable used by MorphOS to show the version.
  */
-extern const char morphos_versions_tag[] = "$VER: OpenTTD @@VERSION@@ (@@DATE@@) OpenTTD Team [MorphOS, PowerPC]";
+extern const char morphos_versions_tag[] = "$VER: OpenTTD IS2.0-beta2 (@@DATE@@) OpenTTD Team [MorphOS, PowerPC]";
 #endif
diff -r ee55d0546576 src/roadveh_cmd.cpp
--- a/src/roadveh_cmd.cpp	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/roadveh_cmd.cpp	Sat Apr 25 19:58:24 2009 +0200
@@ -30,6 +30,7 @@
 #include "depot_base.h"
 #include "effectvehicle_func.h"
 #include "settings_type.h"
+#include "infrastructure_func.h"
 
 #include "table/strings.h"
 #include "table/sprites.h"
@@ -175,7 +176,7 @@
 	/* The ai_new queries the vehicle cost before building the route,
 	 * so we must check against cheaters no sooner than now. --pasky */
 	if (!IsRoadDepotTile(tile)) return CMD_ERROR;
-	if (!IsTileOwner(tile, _current_company)) return CMD_ERROR;
+	if (!AreDepotOperationsAllowed(tile, _current_company, VEH_ROAD)) return CMD_ERROR;
 
 	if (HasTileRoadType(tile, ROADTYPE_TRAM) != HasBit(EngInfo(p1)->misc_flags, EF_ROAD_TRAM)) return_cmd_error(STR_DEPOT_WRONG_DEPOT_TYPE);
 
@@ -363,7 +364,7 @@
 	tile += TileOffsByDiagDir(_road_pf_directions[trackdir]);
 
 	if (IsRoadDepotTile(tile) &&
-			IsTileOwner(tile, rfdd->owner) &&
+			IsDepotUsageAllowed(tile, rfdd->owner, VEH_ROAD) &&
 			length < rfdd->best_length) {
 		rfdd->best_length = length;
 		rfdd->tile = tile;
@@ -456,7 +457,7 @@
 
 	v = GetVehicle(p1);
 
-	if (v->type != VEH_ROAD || !CheckOwnership(v->owner)) return CMD_ERROR;
+	if (v->type != VEH_ROAD || !IsVehicleControlAllowed(v)) return CMD_ERROR;
 
 	if (v->vehstatus & VS_STOPPED ||
 			v->vehstatus & VS_CRASHED ||
@@ -1032,14 +1033,14 @@
 	TrackdirBits trackdirs = TrackStatusToTrackdirBits(ts);
 
 	if (IsTileType(tile, MP_ROAD)) {
-		if (IsRoadDepot(tile) && (!IsTileOwner(tile, v->owner) || GetRoadDepotDirection(tile) == enterdir || (GetRoadTypes(tile) & v->u.road.compatible_roadtypes) == 0)) {
+		if (IsRoadDepot(tile) && (!IsDepotUsageAllowed(tile, v) || GetRoadDepotDirection(tile) == enterdir || (GetRoadTypes(tile) & v->u.road.compatible_roadtypes) == 0)) {
 			/* Road depot owned by another company or with the wrong orientation */
 			trackdirs = TRACKDIR_BIT_NONE;
 		}
 	} else if (IsTileType(tile, MP_STATION) && IsStandardRoadStopTile(tile)) {
 		/* Standard road stop (drive-through stops are treated as normal road) */
 
-		if (!IsTileOwner(tile, v->owner) || GetRoadStopDir(tile) == enterdir || RoadVehHasArticPart(v)) {
+		if (!IsStationUsageAllowed(tile, v) || GetRoadStopDir(tile) == enterdir || RoadVehHasArticPart(v)) {
 			/* different station owner or wrong orientation or the vehicle has articulated parts */
 			trackdirs = TRACKDIR_BIT_NONE;
 		} else {
@@ -1648,7 +1649,7 @@
 			_road_veh_data_1[v->u.road.state - RVSB_IN_ROAD_STOP + (_settings_game.vehicle.road_side << RVS_DRIVE_SIDE)] == v->u.road.frame) ||
 			(IsInsideMM(v->u.road.state, RVSB_IN_DT_ROAD_STOP, RVSB_IN_DT_ROAD_STOP_END) &&
 			v->current_order.ShouldStopAtStation(v, GetStationIndex(v->tile)) &&
-			v->owner == GetTileOwner(v->tile) &&
+			IsStationUsageAllowed(v->tile, v) &&
 			GetRoadStopType(v->tile) == (IsCargoInClass(v->cargo_type, CC_PASSENGERS) ? ROADSTOP_BUS : ROADSTOP_TRUCK) &&
 			v->u.road.frame == RVC_DRIVE_THROUGH_STOP_FRAME))) {
 
diff -r ee55d0546576 src/saveload/afterload.cpp
--- a/src/saveload/afterload.cpp	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/saveload/afterload.cpp	Sat Apr 25 19:58:24 2009 +0200
@@ -1805,6 +1805,36 @@
 		}
 	}
 
+	if (CheckSavegameVersion(SL_IS)) {
+		/* Set the sharing settings to the standard values (no sharing)
+		 * as we do not want these to be copied from the newgame settings. */
+		_settings_game.sharing.enable_sharing       = false;
+		_settings_game.sharing.individual_allowed   = false;
+		_settings_game.sharing.new_individual_delay = 12;
+		_settings_game.sharing.rail_sharing         = 0;
+		_settings_game.sharing.road_sharing         = false;
+		_settings_game.sharing.water_sharing        = false;
+		_settings_game.sharing.air_sharing          = false;
+		_settings_game.sharing.rail_fee             = 100;
+		_settings_game.sharing.road_fee             = 100;
+		_settings_game.sharing.water_fee            = 100;
+		_settings_game.sharing.air_fee              = 100;
+
+		Company *c;
+		FOR_ALL_COMPANIES(c) {
+			c->sharing_future.CopyFromGameSettings();
+			c->sharing_current.CopyFromGameSettings();
+			/* yearly_expenses has 3*15 entries now, saveload code gave us 3*13.
+			 * Move the old data to the right place in the new array and clear the new data.
+			 * The move has to be done in reverse order (first 2, then 1). */
+			MemMoveT(&c->yearly_expenses[2][0], &c->yearly_expenses[0][2 * 13], 13);
+			MemMoveT(&c->yearly_expenses[1][0], &c->yearly_expenses[0][13],     13);
+			/* Clear the old location of just-moved data, so sharing income/expenses is set to 0 */
+			MemSetT(&c->yearly_expenses[0][13], 0, 2);
+			MemSetT(&c->yearly_expenses[1][13], 0, 2);
+		}
+	}
+
 	AfterLoadLabelMaps();
 
 	GamelogPrintDebug(1);
diff -r ee55d0546576 src/saveload/company_sl.cpp
--- a/src/saveload/company_sl.cpp	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/saveload/company_sl.cpp	Sat Apr 25 19:58:24 2009 +0200
@@ -125,7 +125,8 @@
 
 	/* yearly expenses was changed to 64-bit in savegame version 2. */
 	SLE_CONDARR(Company, yearly_expenses,       SLE_FILE_I32 | SLE_VAR_I64, 3 * 13, 0, 1),
-	SLE_CONDARR(Company, yearly_expenses,       SLE_INT64, 3 * 13,                  2, SL_MAX_VERSION),
+	SLE_CONDARR(Company, yearly_expenses,       SLE_INT64, 3 * 13,                  2, SL_IS - 1),
+	SLE_CONDARR(Company, yearly_expenses,       SLE_INT64, 3 * 15,              SL_IS, SL_MAX_VERSION),
 
 	SLE_CONDVAR(Company, is_ai,                 SLE_BOOL,                    2, SL_MAX_VERSION),
 	SLE_CONDNULL(1, 107, 111), ///< is_noai
@@ -138,6 +139,8 @@
 	SLE_CONDVAR(Company, engine_renew_months,   SLE_INT16,                  16, SL_MAX_VERSION),
 	SLE_CONDVAR(Company, engine_renew_money,    SLE_UINT32,                 16, SL_MAX_VERSION),
 	SLE_CONDVAR(Company, renew_keep_length,     SLE_BOOL,                    2, SL_MAX_VERSION), // added with 16.1, but was blank since 2
+
+	SLE_CONDVAR(Company, sharing_delay,         SLE_UINT8,               SL_IS, SL_MAX_VERSION),
 
 	/* Reserve extra space in savegame here. (currently 63 bytes) */
 	SLE_CONDNULL(63, 2, SL_MAX_VERSION),
@@ -212,6 +215,13 @@
 	SLE_END()
 };
 
+static const SaveLoad _company_sharing_desc[] = {
+	SLE_CONDARR(CompanySharingSettingsEntry,            option,  SLE_UINT8, 4, SL_IS, SL_MAX_VERSION),
+	SLE_CONDARR(CompanySharingSettingsEntry,               fee, SLE_UINT16, 4, SL_IS, SL_MAX_VERSION),
+	SLE_CONDVAR(CompanySharingSettingsEntry, allowed_companies, SLE_UINT16,    SL_IS, SL_MAX_VERSION),
+	SLE_END()
+};
+
 static void SaveLoad_PLYR(Company *c)
 {
 	int i;
@@ -228,6 +238,10 @@
 			SlObject(&nothing, _company_ai_build_rec_desc);
 		}
 	}
+
+	/* Write sharing settings */
+	SlObject(&c->sharing_current, _company_sharing_desc);
+	SlObject(&c->sharing_future,  _company_sharing_desc);
 
 	/* Write economy */
 	SlObject(&c->cur_economy, _company_economy_desc);
diff -r ee55d0546576 src/saveload/saveload.cpp
--- a/src/saveload/saveload.cpp	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/saveload/saveload.cpp	Sat Apr 25 19:58:24 2009 +0200
@@ -40,7 +40,7 @@
 
 #include "saveload_internal.h"
 
-extern const uint16 SAVEGAME_VERSION = 118;
+extern const uint16 SAVEGAME_VERSION = SL_IS;
 
 SavegameType _savegame_type; ///< type of savegame we are loading
 
diff -r ee55d0546576 src/saveload/saveload.h
--- a/src/saveload/saveload.h	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/saveload/saveload.h	Sat Apr 25 19:58:24 2009 +0200
@@ -72,6 +72,7 @@
 };
 
 #define SL_MAX_VERSION 255
+#define SL_IS 119
 
 enum {
 	INC_VEHICLE_COMMON = 0,
diff -r ee55d0546576 src/settings.cpp
--- a/src/settings.cpp	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/settings.cpp	Sat Apr 25 19:58:24 2009 +0200
@@ -60,6 +60,8 @@
 
 #include "void_map.h"
 #include "station_base.h"
+#include "infrastructure_func.h"
+#include "core/mem_func.hpp"
 
 #include "table/strings.h"
 #include "table/settings.h"
@@ -969,6 +971,83 @@
 	return true;
 }
 
+/**
+ * Update the sharing settings of all companies if sharing is enabled, and individual settings are disabled
+ * @param p1 unused
+ * @return always true
+ */
+static bool UpdateAllSharingSettings(int32 p1)
+{
+	InvalidateWindowClasses(WC_COMPANY);
+	if (!(_settings_game.sharing.enable_sharing && _settings_game.sharing.individual_allowed)) {
+		DeleteWindowByClass(WC_SHARING_OPTIONS);
+	}
+	if (_settings_game.sharing.individual_allowed) return true;
+	/* If individual settings are disallowed, copy the game settings to all companies */
+	Company *c;
+	byte changed_vehtypes = 0;
+	FOR_ALL_COMPANIES(c) {
+		changed_vehtypes |= c->sharing_current.CopyFromGameSettings();
+		c->sharing_future.CopyFromGameSettings();
+		c->sharing_delay = 0;
+	}
+	HandleSharingChange(changed_vehtypes);
+
+	return true;
+}
+
+/**
+ * Update all sharing settings if sharing is globally enabled / disabled.
+ * @param p1 unused
+ * @return always true
+ */
+static bool UpdateSharingEnabled(int32 p1)
+{
+	if (!_settings_game.sharing.enable_sharing) {
+		/* Sharing was disabled, do this for all companies */
+		Company *c;
+		FOR_ALL_COMPANIES(c) {
+			/* Disable all sharing options */
+			MemSetT(c->sharing_current.option, 0, SHARING_VEHTYPES);
+			/* Make future settings the same as current ones */
+			c->sharing_future.Copy(&c->sharing_current);
+			c->sharing_delay = 0;
+			/* Always allow our own company */
+			c->sharing_current.allowed_companies = 1 << c->index;
+			c->sharing_future.allowed_companies  = 1 << c->index;
+		}
+		HandleSharingChange(); //invalidate everything
+	} else {
+		HandleSharingChange(1 << VEH_TRAIN); //Invalidate all signal blocks.
+	}
+	/* Invalidate / delete windows, and possibly copy game settings to companies,
+	 * if individual settings are off and sharing has just been enabled */
+	UpdateAllSharingSettings(0);
+	InvalidateWindowClasses(WC_FINANCES);
+	return true;
+}
+
+/**
+ * Cap sharing_delay for all companies to the new delay setting
+ * @param p1 new delay setting
+ * @return always true
+ */
+static bool UpdateSharingDelay(int32 p1)
+{
+	if (!(_settings_game.sharing.enable_sharing && _settings_game.sharing.individual_allowed)) return true;
+
+	byte changed_vehtypes = 0;
+	Company *c;
+	FOR_ALL_COMPANIES(c) {
+		c->sharing_delay = min(c->sharing_delay, p1);
+		/* Delay set to 0 and we have changes pending, apply them now */
+		if (p1 == 0 && !c->sharing_current.Equals(&c->sharing_future)) changed_vehtypes |= c->sharing_current.Copy(&c->sharing_future);
+	}
+	HandleSharingChange(changed_vehtypes);
+	InvalidateWindowClasses(WC_SHARING_OPTIONS);
+	return true;
+}
+
 #ifdef ENABLE_NETWORK
 
 static bool UpdateClientName(int32 p1)
diff -r ee55d0546576 src/settings_gui.cpp
--- a/src/settings_gui.cpp	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/settings_gui.cpp	Sat Apr 25 19:58:24 2009 +0200
@@ -1235,8 +1235,25 @@
 /** Computer players sub-page */
 static SettingsPage _settings_ai_npc_page = {_settings_ai_npc, lengthof(_settings_ai_npc)};
 
+static SettingEntry _settings_ai_sharing[] = {
+	SettingEntry("sharing.enable_sharing"),
+	SettingEntry("sharing.individual_allowed"),
+	SettingEntry("sharing.new_individual_delay"),
+	SettingEntry("sharing.rail_sharing"),
+	SettingEntry("sharing.road_sharing"),
+	SettingEntry("sharing.water_sharing"),
+	SettingEntry("sharing.air_sharing"),
+	SettingEntry("sharing.rail_fee"),
+	SettingEntry("sharing.road_fee"),
+	SettingEntry("sharing.water_fee"),
+	SettingEntry("sharing.air_fee"),
+};
+/** Infrastructure sharing sub-page */
+static SettingsPage _settings_ai_sharing_page = {_settings_ai_sharing, lengthof(_settings_ai_sharing)};
+
 static SettingEntry _settings_ai[] = {
 	SettingEntry(&_settings_ai_npc_page, STR_CONFIG_SETTING_AI_NPC),
+	SettingEntry(&_settings_ai_sharing_page, STR_CONFIG_SETTING_AI_SHARING),
 	SettingEntry("economy.give_money"),
 	SettingEntry("economy.allow_shares"),
 };
diff -r ee55d0546576 src/settings_type.h
--- a/src/settings_type.h	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/settings_type.h	Sat Apr 25 19:58:24 2009 +0200
@@ -185,6 +185,23 @@
 	uint32 ai_max_opcode_till_suspend;       ///< max opcode calls till AI will suspend
 };
 
+/** Settings related to sharing. */
+struct SharingSettings {
+	bool   enable_sharing;                   ///< globally enable/disable infrastructure sharing
+	bool   individual_allowed;               ///< allow individual settings?
+	byte   new_individual_delay;             ///< time (in months) it takes for new individual settings to take effect
+
+	byte   rail_sharing;                     ///< sharing rail
+	bool   road_sharing;                     ///< sharing road
+	bool   water_sharing;                    ///< sharing water
+	bool   air_sharing;                      ///< sharing air
+
+	uint16 rail_fee;                         ///< train fee
+	uint16 road_fee;                         ///< road vehicle fee
+	uint16 water_fee;                        ///< ship fee
+	uint16 air_fee;                          ///< aircraft fee
+};
+
 /** Settings related to the old pathfinder. */
 struct OPFSettings {
 	uint16 pf_maxlength;                     ///< maximum length when searching for a train route for new pathfinder
@@ -354,6 +371,7 @@
 	EconomySettings      economy;            ///< settings to change the economy
 	StationSettings      station;            ///< settings related to station management
 	LocaleSettings       locale;             ///< settings related to used currency/unit system in the current game
+	SharingSettings      sharing;            ///< settings related to infrastructure sharing
 };
 
 /** All settings that are only important for the local client. */
diff -r ee55d0546576 src/ship_cmd.cpp
--- a/src/ship_cmd.cpp	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/ship_cmd.cpp	Sat Apr 25 19:58:24 2009 +0200
@@ -30,6 +30,7 @@
 #include "settings_type.h"
 #include "ai/ai.hpp"
 #include "pathfind.h"
+#include "infrastructure_func.h"
 
 #include "table/strings.h"
 #include "table/sprites.h"
@@ -113,7 +114,7 @@
 
 	FOR_ALL_DEPOTS(depot) {
 		TileIndex tile = depot->xy;
-		if (IsShipDepotTile(tile) && IsTileOwner(tile, v->owner)) {
+		if (IsShipDepotTile(tile) && IsDepotUsageAllowed(tile, v)) {
 			uint dist = DistanceManhattan(tile, v->tile);
 			if (dist < best_dist) {
 				best_dist = dist;
@@ -741,7 +742,7 @@
 	/* The ai_new queries the vehicle cost before building the route,
 	 * so we must check against cheaters no sooner than now. --pasky */
 	if (!IsShipDepotTile(tile)) return CMD_ERROR;
-	if (!IsTileOwner(tile, _current_company)) return CMD_ERROR;
+	if (!AreDepotOperationsAllowed(tile, _current_company, VEH_SHIP)) return CMD_ERROR;
 
 	unit_num = (flags & DC_AUTOREPLACE) ? 0 : GetFreeUnitNumber(VEH_SHIP);
 
diff -r ee55d0546576 src/signal.cpp
--- a/src/signal.cpp	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/signal.cpp	Sat Apr 25 19:58:24 2009 +0200
@@ -9,6 +9,7 @@
 #include "vehicle_func.h"
 #include "vehicle_base.h"
 #include "functions.h"
+#include "infrastructure_func.h"
 
 
 /** these are the maximums used for updating signal blocks */
@@ -272,7 +273,7 @@
 
 		switch (GetTileType(tile)) {
 			case MP_RAILWAY: {
-				if (GetTileOwner(tile) != owner) continue; // do not propagate signals on others' tiles (remove for tracksharing)
+				if (!AreSignalBlocksJoined(owner, GetTileOwner(tile))) continue; // check whether tile should be part of the same block, owner-wise
 
 				if (IsRailDepot(tile)) {
 					if (enterdir == INVALID_DIAGDIR) { // from 'inside' - train just entered or left the depot
@@ -353,7 +354,7 @@
 
 			case MP_STATION:
 				if (!IsRailwayStation(tile)) continue;
-				if (GetTileOwner(tile) != owner) continue;
+				if (!AreSignalBlocksJoined(owner, GetTileOwner(tile)))
 				if (DiagDirToAxis(enterdir) != GetRailStationAxis(tile)) continue; // different axis
 				if (IsStationTileBlocked(tile)) continue; // 'eye-candy' station tile
 
@@ -363,7 +364,7 @@
 
 			case MP_ROAD:
 				if (!IsLevelCrossing(tile)) continue;
-				if (GetTileOwner(tile) != owner) continue;
+				if (!AreSignalBlocksJoined(owner, GetTileOwner(tile))) continue;
 				if (DiagDirToAxis(enterdir) == GetCrossingRoadAxis(tile)) continue; // different axis
 
 				if (!(flags & SF_TRAIN) && HasVehicleOnPos(tile, NULL, &TrainOnTileEnum)) flags |= SF_TRAIN;
@@ -371,7 +372,7 @@
 				break;
 
 			case MP_TUNNELBRIDGE: {
-				if (GetTileOwner(tile) != owner) continue;
+				if (!AreSignalBlocksJoined(owner, GetTileOwner(tile))) continue;
 				if (GetTunnelBridgeTransportType(tile) != TRANSPORT_RAIL) continue;
 				DiagDirection dir = GetTunnelBridgeDirection(tile);
 
